#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "kernel.h"

#define POST_INFO_NUM	24
extern char dbg_msg[128];
struct val_post_stuct {
    char  *name;
    char  *string;	
	char   strlen;
};
static struct val_post_stuct get_post_info[POST_INFO_NUM];

static char val_str[]={'L', 'H'};

static unsigned char printDouble(float v, unsigned char decimalDigits, char *output_str)
{
  int i = 1;
  int intPart, fractPart;
  unsigned char dcma, ret;

  dcma = decimalDigits;
  for (;dcma!=0; i*=10, dcma--);
  intPart = (int)v;
  fractPart = (int)((v-(float)(int)v)*i);
  ret = sprintf(output_str, "%i.%i", intPart, fractPart);
  return ret;
}

static unsigned short GetPostCmd(char *postdata)
{
    unsigned short idx;
	char flag;
	char *pos, *str;
	unsigned char i;

	str = postdata;

	idx = 0;
	flag = 1;
	do {
		pos = strchr(str, '=');
		if (pos == 0) {
			break;
		}
		pos[0] = 0;
		get_post_info[idx].name = str;

		str = pos + 1;
		pos = strchr(str, '&');
		if (pos == 0) {
			flag = 0;
		} else {
			pos[0] = 0;
		}
		get_post_info[idx].string = str;	
		if (flag == 0) {
			for(i=0; i<40; i++) {
				if (str[i] == 0) {
					break;
				}
			}
			get_post_info[idx].strlen = i;
		} else {
			get_post_info[idx].strlen = pos-str;
		}
		idx++;
		if (flag) {
			pos++;
			str = pos;
		}
	} while(flag && (idx < POST_INFO_NUM));

	return (idx);
}


int fetch_di_value(char *ajax_buf_ptr)
{
	int i, len = 0, ret, val;
	unsigned char val_bit, di_val[2];

	len += sprintf(&ajax_buf_ptr[len], "{\n\t\"type\":\"%s\",\n", "DigitalInuput");
	len += sprintf(&ajax_buf_ptr[len], "\t\"action\":\"%s\",\n", "GET");

	ret = DI_Read(di_val);
	val = di_val[0] + di_val[1]*0x0100;

	len += sprintf(&ajax_buf_ptr[len], "%s", "\t\"response\":{\n");
	len += sprintf(&ajax_buf_ptr[len], "\t\t\"items\":%d,\n", ret);
	len += sprintf(&ajax_buf_ptr[len], "%s", "\t\t\"data\":[\n");	

	for(i=0; i<ret; i++) {
		val_bit = val&0x00000001;
		len += sprintf(&ajax_buf_ptr[len], "\t\t{\"key\":\"DI%u\",\"val\":\"%c\"}", (i+1), val_str[val_bit]);
		if (i<(ret-1)) {
			len += sprintf(&ajax_buf_ptr[len], "%s", ",");
		}
		len += sprintf(&ajax_buf_ptr[len], "%s", "\n");
		val = val>>1;
	}
	len += sprintf(&ajax_buf_ptr[len], "%s", "\t]}\n");
	len += sprintf(&ajax_buf_ptr[len], "%s", "}\n");
	return len;					   
}
int fetch_do_value(char *ajax_buf_ptr)
{
	int i, len = 0, ret;
	unsigned char val_bit, do_val;

	len += sprintf(&ajax_buf_ptr[len], "{\n\t\"type\":\"%s\",\n", "DigitalOutput");
	len += sprintf(&ajax_buf_ptr[len], "\t\"action\":\"%s\",\n", "GET");

	ret = DO_Read(&do_val);

	len += sprintf(&ajax_buf_ptr[len], "%s", "\t\"response\":{\n");
	len += sprintf(&ajax_buf_ptr[len], "\t\t\"items\":%d,\n", ret);
	len += sprintf(&ajax_buf_ptr[len], "%s", "\t\t\"data\":[\n");	

	for(i=0; i<ret; i++) {
		val_bit = do_val&0x00000001;
		len += sprintf(&ajax_buf_ptr[len], "\t\t{\"key\":\"DO%u\",\"val\":\"%c\"}", (i+1), val_str[val_bit]);
		if (i<(ret-1)) {
			len += sprintf(&ajax_buf_ptr[len], "%s", ",");
		}
		len += sprintf(&ajax_buf_ptr[len], "%s", "\n");
		do_val = do_val>>1;
	}
	len += sprintf(&ajax_buf_ptr[len], "%s", "\t]}\n");
	len += sprintf(&ajax_buf_ptr[len], "%s", "}\n");
	return len;					   
}
int set_do_value(char *ajax_buf_ptr, char *post_data, unsigned short post_len)
{
	unsigned char i, post_item, idx, val;

	post_item = GetPostCmd(post_data);
	for(i=0; ((i<post_item)&&(i<DO_SUM)); i++) {
		if (strlen(get_post_info[i].name) != 3) {
			return 0;
		}		
		if ((strncmp(get_post_info[i].name, "DO", 2) != 0) || 
			((get_post_info[i].name[2] < '1') || (get_post_info[i].name[2] > '8'))){
			return 0;
		}
		idx = get_post_info[i].name[2] - '0';
		if (get_post_info[i].string[0] == 'H') {
			val = 1;
		} else if (get_post_info[i].string[0] == 'L') {
			val = 0;
		} else {
			return 0;
		}

		DO_WriteBit(idx, val);
	}
	return fetch_do_value(ajax_buf_ptr);
}
int fetch_tp_value(char *ajax_buf_ptr)
{
	int len = 0;
	unsigned char i, j, ret;
	struct sensor_struct sensor[SENSOR_MAX];
														   
	len += sprintf(&ajax_buf_ptr[len], "{\n\t\"type\":\"%s\",\n", "Temperature");
	len += sprintf(&ajax_buf_ptr[len], "\t\"action\":\"%s\",\n", "GET");

	len += sprintf(&ajax_buf_ptr[len], "%s", "\t\"response\":{\n");
	len += sprintf(&ajax_buf_ptr[len], "%s", "\t\t\"unit\":\"C\",\n");

	ret = Sensor_ReadAll(0, sensor);
	len += sprintf(&ajax_buf_ptr[len], "\t\t\"items\":%d", ret);
	if (ret > 0) {
		len += sprintf(&ajax_buf_ptr[len], "%s", ",\n\t\t\"data\":[\n");		
		for(i=0; i<ret; i++) {
			len += sprintf(&ajax_buf_ptr[len], "%s", "\t\t{\"key\":\"");
			for(j=0; j<8; j++) {
				len += sprintf(&ajax_buf_ptr[len], "%02X", sensor[i].id[j]);
			}
			len += sprintf(&ajax_buf_ptr[len], "%s", "\",\"val\":\"");
			len += printDouble(sensor[i].value, 1, &ajax_buf_ptr[len]);
			len += sprintf(&ajax_buf_ptr[len], "%s", "\"}");

			if (i<(ret-1)) {
				len += sprintf(&ajax_buf_ptr[len], "%s", ",");
			}
			len += sprintf(&ajax_buf_ptr[len], "%s", "\n");
		}
		len += sprintf(&ajax_buf_ptr[len], "%s", "\t\t]\n");
	}
	len += sprintf(&ajax_buf_ptr[len], "%s", "\n\t}\n}\n");

	return len;
}

unsigned short web_file_open(char *name, char *ajax_buf_ptr, char method, char *post_data, unsigned short post_len)
{
	unsigned char cmd_type=0;

	if (strstr(name, "/wapi/v1/DI") != 0) {
		cmd_type = 1;  		
	} else if (strstr(name, "/wapi/v1/DO") != 0) {
		if (method == 0) {
			cmd_type = 2;  	
		} else if ((method == 1)&&(post_len > 0)) {
			cmd_type = 3;
		} 
	} else if (strstr(name, "/wapi/v1/TP") != 0) {
		cmd_type = 4;  				
	} else {
		return 0;
	} 	
	if (cmd_type == 1) {
		return (fetch_di_value(ajax_buf_ptr));
	} else 	if (cmd_type == 2) {
		return (fetch_do_value(ajax_buf_ptr));
	} else if (cmd_type == 3) {
		return (set_do_value(ajax_buf_ptr, post_data, post_len));
	} else 	if (cmd_type == 4) {
		return (fetch_tp_value(ajax_buf_ptr));
	}
	return 0;
}



