#include <stdio.h>
#include <string.h>	   
#include "kernel.h"

const char AppVersion[] = "USR V0.01 #";

static char dbg_msg[128];
static char cmd_buf[128];
static unsigned char cmd_idx;

static void process_cmd(int sfd);

void user_main(void *pvParameters)
{
	int lSocket, clientfd;
	struct sockaddr_in sLocalAddr, client_addr;
    int i, addrlen, nbytes;
    char buffer[64];

	sprintf(dbg_msg, "E08 %s(%s %s)\r\n", AppVersion, __DATE__, __TIME__);
    console_write(dbg_msg);

	lSocket = socket(AF_INET, SOCK_STREAM, 0);
	if (lSocket < 0) {
		sprintf(dbg_msg, "%s\r\n", "socket failed");
    	console_write(dbg_msg);
		return;
	}

	memset((char *)&sLocalAddr, 0, sizeof(sLocalAddr));
	sLocalAddr.sin_family = AF_INET;
	sLocalAddr.sin_len = sizeof(sLocalAddr);
	sLocalAddr.sin_addr.s_addr = htonl(INADDR_ANY);
	sLocalAddr.sin_port = htons(4001);

	if (bind(lSocket, (struct sockaddr *)&sLocalAddr, sizeof(sLocalAddr)) < 0) {
        closesocket(lSocket);
		sprintf(dbg_msg, "%s\r\n", "bind failed");
    	console_write(dbg_msg);
        return;
	}

	if (listen(lSocket, 20) != 0 ){
        closesocket(lSocket);
		sprintf(dbg_msg, "%s\r\n", "listen failed");
    	console_write(dbg_msg);
        return;
	}
	addrlen = sizeof(client_addr);
	while (1) {	 
        clientfd = accept(lSocket, (struct sockaddr*)&client_addr, (socklen_t *)&addrlen);
        if (clientfd > 0){
			sprintf(dbg_msg, "%s\r\n", "accepted");
    		console_write(dbg_msg);
			cmd_idx = 0;
			while(1) {
				nbytes = recv(clientfd, buffer, sizeof(buffer),0);
				if (nbytes > 0) {
					for(i=0; i<nbytes; i++) {	 
						if (cmd_idx >= sizeof(cmd_buf)) {
							break;
						}
						cmd_buf[cmd_idx++] = buffer[i];						
					}
					process_cmd(clientfd); 					
				} else {
					sprintf(dbg_msg, "%s\r\n", "closed");
    			console_write(dbg_msg);
					closesocket(clientfd);
					break;
				}
				vTaskDelay(1);
			}			               
        }
		vTaskDelay(1);
    }
}
/*
command example:
DO1=H
DO2=L
*/
static void process_cmd(int sfd)
{
	char *ptr;
	unsigned char do_no, len;

	ptr = strstr(cmd_buf, "\r");
	if (ptr == NULL) {
		return;
	}
	ptr[0] = 0;

	if ((strlen(cmd_buf) != 5) ||
		(strncmp(cmd_buf, "DO", 2) != 0)) {
		cmd_idx = 0;
		len = sprintf(dbg_msg, "%s\r\n", "unknow command");
		send(sfd, dbg_msg, len, 0);
		return;
	}				
	if ((cmd_buf[2] < '1') || (cmd_buf[2] > '8')) {
		cmd_idx = 0;
		len = sprintf(dbg_msg, "%s\r\n", "unknow command");
		send(sfd, dbg_msg, len, 0);
		return;
	}			 

	do_no = cmd_buf[2] - '0';
	if (cmd_buf[4] == 'H') {
		DO_WriteBit(do_no, 1);
		len = sprintf(dbg_msg, "Set DO%d=H OK\r\n", do_no);	
	} else 	if (cmd_buf[4] == 'L') {
		DO_WriteBit(do_no, 0);
		len = sprintf(dbg_msg, "Set DO%d=L OK\r\n", do_no);		
	} else {
		len = sprintf(dbg_msg, "%s\r\n", "unknow command");		
	}
	send(sfd, dbg_msg, len, 0);
	cmd_idx = 0;
	return;
}
