#ifndef __USER_SERIAL_H__
#define __USER_SERIAL_H__

#define RS232	0x00
#define RS485	0x01
#define RS422	0x02

#define  B1200  1200
#define  B2400  2400
#define  B4800  4800
#define  B7200  7200
#define  B9600  9600
#define  B19200 19200
#define  B38400 38400
#define  B57600 57600
#define  B115200 115200
#define  B230400 230400
#define  B460800 460800

int prg_uart_Open(int port_no, int type);
int prg_uart_Close(int port_no);
int prg_uart_Config(int port_no, unsigned long baud, char *serial_mode);
int prg_uart_FlowControl(int port_no , char *flowmode);
int pgr_uart_RxTimeoutThreshold(int port_no, int vtime, int vmin);
int prg_uart_puts(int port_no , void *buf , size_t size);
int prg_uart_putc(int port_no , int c);
int prg_uart_gets(int port_no, void *buf , size_t size);
int prg_uart_getc(int port_no);
int prg_uart_Available(int port_no);
int prg_uart_SendBreak(int port_no,int duration);
int prg_uart_GetCTS(int port_no);
int prg_uart_GetDCD(int port_no);
int prg_uart_SetRTS(int port_no,int state);
int prg_uart_GetRTS(int port_no);
int prg_uart_SetDTR(int port_no,int state);
int prg_uart_GetDTR(int port_no);
int prg_uart_SetDSR(int port_no,int state);
int prg_uart_GetDSR(int port_no);

#endif
